<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: OneAxisRotation.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_one_axis_rotation_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">OneAxisRotation.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_one_axis_rotation_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// %flair:license{</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// This file is part of the Flair framework distributed under the</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// CECILL-C License, Version 1.0.</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// %flair:license}</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"></span><span class="preprocessor">#ifndef ONEAXISROTATION_H</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define ONEAXISROTATION_H</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_group_box_8h.html">GroupBox.h</a>&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_vector3_d_8h.html">Vector3D.h</a>&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">class </span>OneAxisRotation_impl;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">namespace </span>gui {</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">class </span>LayoutPosition;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;}</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">namespace </span>core {</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">class </span>Euler;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">class </span>Quaternion;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">class </span>RotationMatrix;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_one_axis_rotation.html">   38</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1core_1_1_one_axis_rotation.html">OneAxisRotation</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1gui_1_1_group_box.html">gui::GroupBox</a> {</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;  <span class="keyword">public</span>:</div>
<div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_one_axis_rotation.html#a327edc6a6cdc6af2abc763aea6618495">   44</a></span>&#160;  <span class="keyword">enum</span> <a class="code" href="classflair_1_1core_1_1_one_axis_rotation.html#a327edc6a6cdc6af2abc763aea6618495">RotationType_t</a> {</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    PreRotation,<span class="comment">//rotation</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    PostRotation<span class="comment">//frame change</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;  };</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;  <a class="code" href="classflair_1_1core_1_1_one_axis_rotation.html#a85a24d18b48761166caa4f037b13ebb4">OneAxisRotation</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1gui_1_1_layout_position.html">gui::LayoutPosition</a> *position, std::string name,<a class="code" href="classflair_1_1core_1_1_one_axis_rotation.html#a327edc6a6cdc6af2abc763aea6618495">RotationType_t</a> rotationType);</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;  <a class="code" href="classflair_1_1core_1_1_one_axis_rotation.html#adb99d2f257c0600f9d56813d1b72fe6b">~OneAxisRotation</a>();</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_one_axis_rotation.html#a59b74b5059d847710803259bd1b8f1c1">ComputeRotation</a>(<a class="code" href="classflair_1_1core_1_1_vector3_d.html">core::Vector3D&lt;T&gt;</a> &amp;vector) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_one_axis_rotation.html#a59b74b5059d847710803259bd1b8f1c1">ComputeRotation</a>(<a class="code" href="classflair_1_1core_1_1_euler.html">core::Euler</a> &amp;euler) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_one_axis_rotation.html#a59b74b5059d847710803259bd1b8f1c1">ComputeRotation</a>(<a class="code" href="classflair_1_1core_1_1_quaternion.html">core::Quaternion</a> &amp;quaternion) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_one_axis_rotation.html#a59b74b5059d847710803259bd1b8f1c1">ComputeRotation</a>(<a class="code" href="classflair_1_1core_1_1_rotation_matrix.html">core::RotationMatrix</a> &amp;matrix) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;  </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;  <span class="keywordtype">float</span> <a class="code" href="classflair_1_1core_1_1_one_axis_rotation.html#a311d0fbae6722ce463f8f20a1c17545b">GetAngle</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;  <span class="keywordtype">int</span> GetAxis() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;  <span class="keyword">const</span> <span class="keyword">class </span>OneAxisRotation_impl *pimpl_;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;};</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;} <span class="comment">// end namespace core</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;} <span class="comment">// end namespace flair</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="preprocessor">#endif // ONEAXISROTATION_H</span></div>
<div class="ttc" id="namespaceflair_html"><div class="ttname"><a href="namespaceflair.html">flair</a></div><div class="ttdoc">namespace of the flair Framework </div><div class="ttdef"><b>Definition:</b> Ahrs.h:19</div></div>
<div class="ttc" id="classflair_1_1core_1_1_one_axis_rotation_html_adb99d2f257c0600f9d56813d1b72fe6b"><div class="ttname"><a href="classflair_1_1core_1_1_one_axis_rotation.html#adb99d2f257c0600f9d56813d1b72fe6b">flair::core::OneAxisRotation::~OneAxisRotation</a></div><div class="ttdeci">~OneAxisRotation()</div><div class="ttdoc">Destructor. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a></div><div class="ttdoc">Class defining a 3D vector. </div><div class="ttdef"><b>Definition:</b> Vector3D.h:29</div></div>
<div class="ttc" id="classflair_1_1gui_1_1_group_box_html"><div class="ttname"><a href="classflair_1_1gui_1_1_group_box.html">flair::gui::GroupBox</a></div><div class="ttdoc">Class displaying a QGroupBox on the ground station. </div><div class="ttdef"><b>Definition:</b> GroupBox.h:27</div></div>
<div class="ttc" id="classflair_1_1core_1_1_one_axis_rotation_html_a85a24d18b48761166caa4f037b13ebb4"><div class="ttname"><a href="classflair_1_1core_1_1_one_axis_rotation.html#a85a24d18b48761166caa4f037b13ebb4">flair::core::OneAxisRotation::OneAxisRotation</a></div><div class="ttdeci">OneAxisRotation(const gui::LayoutPosition *position, std::string name, RotationType_t rotationType)</div><div class="ttdoc">Constructor. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_euler_html"><div class="ttname"><a href="classflair_1_1core_1_1_euler.html">flair::core::Euler</a></div><div class="ttdoc">Class defining euler angles. </div><div class="ttdef"><b>Definition:</b> Euler.h:27</div></div>
<div class="ttc" id="classflair_1_1core_1_1_rotation_matrix_html"><div class="ttname"><a href="classflair_1_1core_1_1_rotation_matrix.html">flair::core::RotationMatrix</a></div><div class="ttdoc">Class defining a rotation matrix. </div><div class="ttdef"><b>Definition:</b> RotationMatrix.h:26</div></div>
<div class="ttc" id="_vector3_d_8h_html"><div class="ttname"><a href="_vector3_d_8h.html">Vector3D.h</a></div><div class="ttdoc">Class defining a 3D vector. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_one_axis_rotation_html"><div class="ttname"><a href="classflair_1_1core_1_1_one_axis_rotation.html">flair::core::OneAxisRotation</a></div><div class="ttdoc">Class defining a rotation around one axis. </div><div class="ttdef"><b>Definition:</b> OneAxisRotation.h:38</div></div>
<div class="ttc" id="classflair_1_1core_1_1_one_axis_rotation_html_a311d0fbae6722ce463f8f20a1c17545b"><div class="ttname"><a href="classflair_1_1core_1_1_one_axis_rotation.html#a311d0fbae6722ce463f8f20a1c17545b">flair::core::OneAxisRotation::GetAngle</a></div><div class="ttdeci">float GetAngle() const </div><div class="ttdoc">Get angle. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_one_axis_rotation_html_a59b74b5059d847710803259bd1b8f1c1"><div class="ttname"><a href="classflair_1_1core_1_1_one_axis_rotation.html#a59b74b5059d847710803259bd1b8f1c1">flair::core::OneAxisRotation::ComputeRotation</a></div><div class="ttdeci">void ComputeRotation(core::Vector3D&lt; T &gt; &amp;vector) const </div><div class="ttdoc">Compute rotation. </div></div>
<div class="ttc" id="_group_box_8h_html"><div class="ttname"><a href="_group_box_8h.html">GroupBox.h</a></div><div class="ttdoc">Class displaying a QGroupBox on the ground station. </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_layout_position_html"><div class="ttname"><a href="classflair_1_1gui_1_1_layout_position.html">flair::gui::LayoutPosition</a></div><div class="ttdoc">Class to define a position in a layout on the ground station. </div><div class="ttdef"><b>Definition:</b> LayoutPosition.h:28</div></div>
<div class="ttc" id="classflair_1_1core_1_1_one_axis_rotation_html_a327edc6a6cdc6af2abc763aea6618495"><div class="ttname"><a href="classflair_1_1core_1_1_one_axis_rotation.html#a327edc6a6cdc6af2abc763aea6618495">flair::core::OneAxisRotation::RotationType_t</a></div><div class="ttdeci">RotationType_t</div><div class="ttdoc">rotation type </div><div class="ttdef"><b>Definition:</b> OneAxisRotation.h:44</div></div>
<div class="ttc" id="classflair_1_1core_1_1_quaternion_html"><div class="ttname"><a href="classflair_1_1core_1_1_quaternion.html">flair::core::Quaternion</a></div><div class="ttdoc">Class defining a quaternion. </div><div class="ttdef"><b>Definition:</b> Quaternion.h:26</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_33c2ee9b1665499374b4225c427cf176.html">igep</a></li><li class="navelem"><a class="el" href="dir_f1fe274389177bd7e17de7949c4ffada.html">flair-src</a></li><li class="navelem"><a class="el" href="dir_3ef62148cf94871b4b6ee5d6e3a989c1.html">lib</a></li><li class="navelem"><a class="el" href="dir_97265977dbbd48c696782ccac102bad5.html">FlairCore</a></li><li class="navelem"><a class="el" href="dir_6c198461db290ac9abcdd44184573216.html">src</a></li><li class="navelem"><a class="el" href="_one_axis_rotation_8h.html">OneAxisRotation.h</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
